#!/usr/bin/perl

###
### Openjade ignores `\\Character{...}' in `\HeadingText{...}'
### which is used for making Bookmark (Outline) in PDF files.
### This script inserts the Bookmark text string in \HeadingText{...}
### in addition to loading `ucshanjadetex.tex'.
###

print "\\input ucshanjadetex\n";

my $chapter = "";

while (<>) {
	if (/\}\}(.+)\. \\Seq\%/) {
		$chapter = "$1\. ";
	}
	elsif(/\\def\\HeadingText\{/) {
		s/
			\}\}
			(.+?)
			(\\end.+\{\})?
			\\def\\HeadingText\{\%
		/
			"\}\}".
			$1.
			$2.
			"\\def\\HeadingText\{\\string\\376\\string\\377".
			to_pdf_oct("$chapter$1").
			"\}".
			"\\\@gobble\{\%"
		/ex;
		$chapter = "";
	}

	print;
}

sub to_pdf_oct {
	my $todo = shift;
	my $done = "";

	while($todo =~ /(.*?)\\Character\{(\d+?)\}(.*)/) {
		$done .= to_pdf_oct_lat($1);
		$done .= to_pdf_oct_uni($2);
		$todo = $3;
	}

	$done .= to_pdf_oct_lat($todo);

	return $done;
}

###
### unicode point number -> two octal numbers
### CAVEAT: works only for BMP area
###
sub to_pdf_oct_uni {
	my $num = shift;
	my $hexa = sprintf "%04X",$num;
	$hexa =~ /([0-9A-F]{2})([0-9A-F]{2})/;
	my $pdf = sprintf "\\string\\%03o\\string\\%03o", hex $1, hex $2;
	return $pdf;
}

###
### latin character -> two octal numbers
###
sub to_pdf_oct_lat {
	my $str = shift;
	$str =~ s/(.)/to_pdf_oct_uni(ord $1)/geo;
	return $str;
}
